MODULE ExeED;

(*
   This programs perfroms the command "Ed SYS:S/Startup-Sequence"
   from the Workbench.

         Written by  Hernando Barake
                     Box 2648
                     Worcester Polytechnic Institute
                     Worcester, MA 01609

         Distribute freely but please leave my name in.
                                                               *)

FROM SYSTEM IMPORT ADDRESS, NULL;
FROM WBStart IMPORT GetWBStartUpMsg, ReturnWBStartUpMsg;
FROM DOSLibrary IMPORT DOSName, DOSBase;
FROM DOSFiles IMPORT Open, Close, ModeOldFile, FileHandle, Lock,
                     Unlock, FileLock, AccessRead;
FROM DOSCodeLoader IMPORT Execute;
FROM Libraries IMPORT OpenLibrary, CloseLibrary;
FROM Screens IMPORT DisplayBeep;
FROM Intuition IMPORT IntuitionBase, IntuitionName;

(*$S-,$T-,$A+*)

VAR
        NilFh:  FileHandle;
        command:  ARRAY [0..30] OF CHAR;
        WBMessage :  ADDRESS;
        lock1, lock2  :  FileLock;

BEGIN 
  IntuitionBase := OpenLibrary(IntuitionName,0);
  WBMessage := GetWBStartUpMsg();
  DOSBase := OpenLibrary(DOSName,0);
  NilFh := Open("NIL:",ModeOldFile);
  lock1 := Lock("c:ed",AccessRead);
  IF lock1 # 0 THEN
    lock2 := Lock("SYS:S",AccessRead);
    IF lock2 # 0 THEN
      command := "Ed SYS:s/Startup-sequence";
      IF Execute(command,0,NilFh) THEN END;
    ELSE
      DisplayBeep(NULL)
    END;
    Unlock(lock2);
  ELSE
    DisplayBeep(NULL)
  END;
  Unlock(lock1);
  Close(NilFh);
  CloseLibrary(DOSBase);
  IF WBMessage <> NULL THEN
    ReturnWBStartUpMsg;
  END;
  CloseLibrary(IntuitionBase);
END ExeED.
