MODULE Viewer;

(** ------------------------------------------------------------------

                       Wanna see some ASCII files ???

          Copyright (c) 1987 Vertex Associates.  All Rights Reserved

             ---> Created for AMnews.  This IS Public Domain <---

   *** FEEL FREE TO INCLUDE THIS UTILITY IN ANY COMMERCIAL SOFTWARE ***

    ------------------------------------------------------------------ **)

(**                                   //
                                     //
                                    //
                                   \_/    Vertex
                            ======> . <======
                                    _    Associates
                                   / \
                                   //
                                  //
                                 //                                     **)

(* VERSION FOR COMMODORE AMIGA

     Original Author : Martin Taillefer.  04-Jul-87

     Version         : 1.00a  04-Jul-87  Martin Taillefer.
                         Original.

  *)

(*==========================================================================*)
(* Written for TDI Modula-2/Amiga V3.00a                                    *)
(*==========================================================================*)

(*$S-,$T-,$A+*)

FROM SYSTEM     IMPORT ADR, ADDRESS, BYTE, TSIZE, NULL, CODE, SETREG;
FROM Intuition  IMPORT IntuitionName, IntuitionBase, Gadget, GadgetFlags,
                      GadgetFlagSet, WindowFlags, WindowFlagSet, IDCMPFlags,
                      IDCMPFlagSet, ActivationFlags, ActivationFlagSet,
                      boolgadget, propgadget, PropFlags, PropFlagSet, PropInfo,
                      ScreenPtr, WindowPtr, NewWindow, CustomScreen, Image,
                      SmartRefresh, ScreenFlags, ScreenFlagSet, CursorDown,
                      IntuiMessagePtr, GadgetPtr, SelectUp, CursorUp,
                      Menu, MenuPtr, MenuItem, ItemFlags, ItemFlagSet,
                      MenuFlags, MenuFlagSet, IntuitionText, MenuNULL;
FROM Views      IMPORT Modes, ModeSet;
FROM Gadgets    IMPORT HighNone, NewModifyProp;
FROM Menus      IMPORT SetMenuStrip, ClearMenuStrip, HighComp;
FROM Screens    IMPORT OpenScreen, CloseScreen, NewScreen;
FROM Windows    IMPORT OpenWindow, CloseWindow, ModifyIDCMP, SetWindowTitles,
                       ClearPointer, SetPointer;
FROM Rasters    IMPORT RastPortPtr, ScrollRaster;
FROM Strings    IMPORT Concat;
FROM Pens       IMPORT SetAPen, RectFill, Move;
FROM Ports      IMPORT GetMsg, ReplyMsg, WaitPort, MessagePtr, Message;
FROM Text       IMPORT TextAttr, FontStyles, FontStyleSet, FontFlags, 
                       FontFlagSet;
FROM DOSFiles   IMPORT Open, Close, Examine, Lock, Unlock, ModeOldFile,
                       FileHandle, FileInfoBlockPtr, FileInfoBlock, CurrentDir,
                       FileLock, AccessRead, Read, Write, ModeNewFile;
FROM DOSLibrary IMPORT DOSBase, DOSName;
FROM Libraries  IMPORT OpenLibrary, CloseLibrary;
FROM Memory     IMPORT AllocMem, FreeMem, MemReqSet, MemPublic, CopyMem,
                       MemChip;
FROM StartupCode       IMPORT StartUp, CloseUp, GetNextArgument, myproc;
FROM GraphicsLibrary   IMPORT GraphicsBase, GraphicsName, Jam1;


TYPE
  CHARPtr  = POINTER TO CHAR;
  ARRAYPtr = POINTER TO ARRAY [0..32767] OF CHARPtr;


VAR
  title    : ARRAY [0..107] OF CHAR;
  fontname : ARRAY [0..10] OF CHAR;
  sp       : ScreenPtr;
  wp,wp2   : WindowPtr;
  rp       : RastPortPtr;
  slider      : PropInfo;
  sliderimage : Image;
  gadgets     : ARRAY [0..2] OF Gadget;
  textattr    : TextAttr;
  msgptr      : MessagePtr;
  quit        : BOOLEAN;
  buffer,buf2 : ADDRESS;
  x           : LONGINT;
  file        : FileHandle;
  filesize    : LONGCARD;
  filename    : ARRAY [0..107] OF CHAR;
  filelock    : FileLock;
  numlines,topline           : CARDINAL;
  i                          : CARDINAL;
  linevalue,shiftvalue,vbody : CARDINAL;
  lineptr                    : ARRAYPtr;
  buf3,pointerdata : ADDRESS;
  numberoflines    : LONGCARD;
  menu             : Menu;
  items            : ARRAY [0..2] OF MenuItem;
  menutext         : ARRAY [0..10] OF CHAR;
  itemstext        : ARRAY [0..9],[0..40] OF CHAR;
  itemsintuitext   : ARRAY [0..9] OF IntuitionText;
  
  
PROCEDURE InitScreen():ScreenPtr;
(* Open a screen with topaz 8 *)
VAR
  ns : NewScreen;
BEGIN
  fontname:="topaz.font";
  WITH textattr DO
    taName  := ADR(fontname);
    taYSize := 8;
    taStyle := FontStyleSet{};
    taFlags := FontFlagSet{ROMFont};
  END;

  WITH ns DO
    LeftEdge    := 0;
    TopEdge     := 0;
    Width       := 640;
    Height      := 200;
    Depth       := 1;
    DetailPen   := BYTE(0);
    BlockPen    := BYTE(1);
    ViewModes   := ModeSet{Hires};
    Type        := CustomScreen;
    Font        := ADR(textattr);
    DefaultTitle:= NULL;
    Gadgets     := NULL;
    CustomBitMap:= NULL;
  END;
  RETURN OpenScreen(ADR(ns));
END InitScreen;


PROCEDURE InitWindow():WindowPtr;
(* open a window *)
VAR
  nw : NewWindow;
BEGIN
  WITH nw DO
    LeftEdge   := 0;
    TopEdge    := 0;
    Width      := 640;
    Height     := 200;
    DetailPen  := BYTE(0);
    BlockPen   := BYTE(1);
    IDCMPFlags := IDCMPFlagSet{GadgetUp,GadgetDown,MouseButtons,MenuPick};
    Flags      := WindowFlagSet{Borderless,Activate,BackDrop}+SmartRefresh;
    FirstGadget:= ADR(gadgets);
    CheckMark  := NULL;
    Title      := NULL;
    Screen     := sp;
    BitMap     := NULL;
    Type       := CustomScreen;
  END;
  RETURN OpenWindow(nw);
END InitWindow;


PROCEDURE InitWindow2():WindowPtr;
(* open a window to hold the close gadget. The reason why I need a second
   window is that I want a close gadget at the top of the display, but I also
   want the user to be able to drag the screen down. I have a window for the
   bottom (under the scroll bar) and a second window just big enough to hold
   a close gadget to sit on the upper left part of the scroll bar  *)
VAR
  nw : NewWindow;
BEGIN
  WITH nw DO
    LeftEdge   := 0;
    TopEdge    := 0;
    Width      := 28;
    Height     := 10;
    DetailPen  := BYTE(0);
    BlockPen   := BYTE(1);
    IDCMPFlags := IDCMPFlagSet{};
    Flags      := WindowFlagSet{RMBTrap,WindowClose}+SmartRefresh;
    FirstGadget:= NULL;
    CheckMark  := NULL;
    Title      := NULL;
    Screen     := sp;
    BitMap     := NULL;
    Type       := CustomScreen;
  END;
  RETURN OpenWindow(nw);
END InitWindow2;


PROCEDURE InitGadgets;
(* guess what this does *)
VAR
  i : CARDINAL;
BEGIN
  FOR i:=0 TO 1 DO
    WITH gadgets[i] DO
      NextGadget := ADR(gadgets[i+1]);
      LeftEdge   := 0;
      TopEdge    := 11+89*i;
      Width      := 626;
      Height     := 89+11*i;
      Flags      := HighNone;
      Activation := ActivationFlagSet{RelVerify,GadgetImmediate};
      GadgetType := boolgadget;
      GadgetText    := NULL;
      MutualExclude := 0;
      GadgetID      := i;
    END;
  END;

  WITH slider DO
    Flags     := PropFlagSet{AutoKnob,FreeVert,PropBorderless};
    HorizPot  := 65535;
    VertPot   := 0;
    HorizBody := 65535;
    VertBody  := 65535;
  END;

  WITH gadgets[2] DO  (* this is the scroll bar *)
    NextGadget := NULL;
    LeftEdge   := 629;
    TopEdge    := 13;
    Width      := 8;
    Height     := 185;
    Flags      := GadgetFlagSet{GadgetImage}+HighNone;
    Activation := ActivationFlagSet{RelVerify};
    GadgetType := propgadget;
    GadgetRender   := ADR(sliderimage); (* because this is autoknob *)
    SelectRender   := NULL;
    GadgetText     := NULL;
    MutualExclude  := 0;
    SpecialInfoProp:= ADR(slider);
    GadgetID       := 2;
  END;
END InitGadgets;


PROCEDURE InitMenu;
(* Another hard one... What does this procedure do ??? *)
BEGIN
  menutext:="Stuff";
  WITH menu DO
    NextMenu  := NULL;
    LeftEdge  := 30;
    TopEdge   := 0;
    Width     := 75;
    Height    := 10;
    Flags     := MenuFlagSet{MenuEnabled};
    MenuName  := ADR(menutext);
    FirstItem := ADR(items[0]);
  END;

  itemstext[0]:="Next File...";
  itemstext[1]:="Print This !";
  itemstext[2]:="--------------------";
  itemstext[3]:="    Viewer V1.00";
  itemstext[4]:="(c) 1987 Vertex Ass.";
  itemstext[5]:="by: Martin Taillefer";
  itemstext[6]:=" Created for AMnews";
  itemstext[7]:="    This is PD !";
  itemstext[8]:="--------------------";
  itemstext[9]:="Quit";

  FOR i:=0 TO 9 DO
    WITH itemsintuitext[i] DO
      FrontPen  := BYTE(0);
      BackPen   := BYTE(1);
      DrawMode  := BYTE(0);
      LeftEdge  := 1;
      TopEdge   := 1;
      ITextFont := NULL;
      NextText  := NULL;
      IText     := ADR(itemstext[i]);
    END;

    IF i<3 THEN
      WITH items[i] DO
        NextItem      := ADR(items[i+1]);
        LeftEdge      := -1;
        TopEdge       := 10*i;
        Width         := 161;
        Height        := 10;
        Flags         := ItemFlagSet{ItemText,ItemEnabled,CommSeq}+HighComp;
        MutualExclude := 0;
        ItemFill      := ADR(itemsintuitext[i]);
        SelectFill    := NULL;
        Command       := BYTE(0);
        SubItem       := NULL;
      END;
    END;
  END;
  items[0].Command:=BYTE(78);  (* Amiga-N *)
  items[1].Command:=BYTE(80);  (* Amiga-P *)
  items[2].TopEdge:=90;
  items[2].Command:=BYTE(81);  (* Amiga-Q *)
  items[2].NextItem:=NULL;
  items[2].ItemFill:=ADR(itemsintuitext[9]);
  FOR i:=1 TO 7 DO
    itemsintuitext[i].NextText:=ADR(itemsintuitext[i+1]);
    itemsintuitext[i+1].TopEdge:=10*INTEGER(i);
  END;
END InitMenu;


(*$P-  This procedure holds the data we need for the ZZ mouse pointer *)
PROCEDURE PointerData;
BEGIN
  CODE(00000H, 00000H,
       00000H, 00000H,
       00000H, 00000H,
       00720H, 00720H,
       00FE0H, 00FE0H,
       03FF0H, 03FF0H,
       07FF0H, 061F0H,
       07FF8H, 07BF8H,
       07FFCH, 077FCH,
       0FFFCH, 0E1FCH,
       03FFEH, 03FFEH,
       07FFFH, 07F0FH,
       03FFEH, 03FDEH,
       07FFEH, 07FBEH,
       03FFCH, 03F0CH,
       01FF8H, 01FF8H,
       007F0H, 007F0H,
       001C0H, 001C0H,
       00700H, 00700H,
       00FC0H, 00FC0H,
       00680H, 00680H,
       00000H, 00000H,
       000C0H, 000C0H,
       000E0H, 000E0H,
       00040H, 00040H,
       00000H, 00000H);
END PointerData;
(*$P=*)


PROCEDURE ZZOn;
BEGIN
(* The reason for the next ModifyIDCMP() is simple. I wish to stop the arrival
   of messages at my window message port while my ZZ pointer is On. By setting
   the SizeVerify flag, it is impossible for me to get any messages since my
   window doesn't have a sizing gadget, thus the SizeVerify message cannot
   occur. Since I am NOT modifying the flags for the second window, I can still
   receive CloseWIndowFlag messages which wil take efect only when the ZZ goes off
   and I enter the main loop again. *)

  ModifyIDCMP(wp,IDCMPFlagSet{SizeVerify});  (* Will NEVER get this message *)
  IF pointerdata=NULL THEN
    pointerdata:=AllocMem(104,MemReqSet{MemChip});
    IF pointerdata # NULL THEN
      CopyMem(ADDRESS(PointerData),pointerdata,104); (* copy from wherever to
                                                        Chip  Mem *)
      SetPointer(wp,pointerdata,24,16,-8,-8);
      SetPointer(wp2,pointerdata,24,16,-8,-8);
    END;
  END;
END ZZOn;


PROCEDURE ZZOff;
BEGIN
  IF pointerdata # NULL THEN
    ClearPointer(wp);
    ClearPointer(wp2);
    FreeMem(pointerdata,104);
    pointerdata:=NULL;
  END;
  ModifyIDCMP(wp,IDCMPFlagSet{GadgetUp,GadgetDown,MouseButtons,MenuPick});
END ZZOff;


PROCEDURE UpdateDisplay;
VAR
  i : CARDINAL;
BEGIN
  SetAPen(rp,0);
  RectFill(rp,0,12,623,195);
  SetAPen(rp,1);
  i:=0;
  WHILE (i<23) & (i+topline<numlines) DO
    Move(rp,0,i*8+18);
    OutputLine(lineptr^[topline+i]);
    INC(i);
  END;
END UpdateDisplay;


PROCEDURE UpDisplay;
BEGIN
  IF topline+23<numlines THEN
    ScrollRaster(rp,0,8,0,12,623,195);
    INC(topline);
    slider.VertPot:=topline*linevalue;
    Move(rp,0,194);
    OutputLine(lineptr^[topline+22]);
  END;
END UpDisplay;


PROCEDURE DownDisplay;
BEGIN
  IF topline>0 THEN
    ScrollRaster(rp,0,-8,0,12,623,195);
    DEC(topline);
    slider.VertPot:=topline*linevalue;
    Move(rp,0,18);
    OutputLine(lineptr^[topline]);
  END;
END DownDisplay;


PROCEDURE OutputLine(ptr:CHARPtr);
VAR
  str : ARRAY [0..88] OF CHAR;
  i,j : CARDINAL;
BEGIN
  i:=0;
  WHILE (ptr^ # 12C) & (ptr<buf2) & (i<78) DO
    IF ptr^=10C THEN
      FOR j:=i TO i+7 DO
        str[j]:=" ";
      END;
      INC(i,8);
      IF i>78 THEN
        i:=78; 
      END;
    ELSE
      str[i]:=ptr^;
      INC(i);
    END;
    INC(ptr);
  END;

  CODE(2F0EH);                   (* A6 --> stack *)
  SETREG(9,rp);                  (* A1 := rastportptr *)
  SETREG(8,ADR(str));            (* A0 := pointer to string *)
  SETREG(0,i);                   (* D0 := length of string *)
  SETREG(14,GraphicsBase);       (* A6 := GraphicsBase *)
  CODE(4EAEH,CARDINAL(-60));     (* JSR TextVec(A6) *)  
  CODE(2C5FH);                   (* Restore A6 from value on stack *)
END OutputLine;


PROCEDURE GetFileSize(VAR name:ARRAY OF CHAR):LONGCARD;
(* There should be a simpler way of geting a file size... Oh well *)
VAR
  fib  : FileInfoBlockPtr;
  lock : FileLock;
  size : LONGCARD;
BEGIN
  size:=0;
  fib:=AllocMem(TSIZE(FileInfoBlock),MemReqSet{MemPublic});
  IF fib # NULL THEN
    lock:=Lock(name,AccessRead);
    IF lock # 0 THEN
      IF Examine(lock,fib^) THEN
        IF fib^.fibDirEntryType<0 THEN
          size:=fib^.fibSize;
        END;
      END;
      Unlock(lock);
    END;
    FreeMem(fib,TSIZE(FileInfoBlock));
  END;
  RETURN size;
END GetFileSize;


PROCEDURE InitGlobs():BOOLEAN;
(* Inits the global variables *)
VAR
  ptr : CHARPtr;
  i,j : CARDINAL;
  l   : LONGCARD;
BEGIN
  topline:=0;
  numlines:=0;
  ptr:=buffer;

  Concat("    ",filename,title);  
  SetWindowTitles(wp,title,title);
  SetWindowTitles(wp2,title,title);

  FOR l:=1 TO filesize DO
    IF ptr^=12C THEN
      INC(numlines);
    END;
    INC(ptr);
  END;
  
  numberoflines:=LONG(numlines)*4+10;
  
  IF numlines>22 THEN
    vbody:=SHORT(65536*22 DIV LONG(numlines)); 
    shiftvalue:=SHORT((LONG(vbody)*65536) DIV (65536-LONG(vbody)));
    linevalue:=SHORT(65536*8 DIV (LONG(numlines-23)*8));
  ELSE
    vbody:=65535;
    shiftvalue:=0;
    linevalue:=0;
  END;
      
  ptr:=buffer;
  lineptr:=AllocMem(numberoflines,MemReqSet{MemPublic});
  buf3:=lineptr;
  IF lineptr # NULL THEN
    lineptr^[0]:=buffer;
    j:=1;
    FOR l:=1 TO filesize DO
      IF ptr^=12C THEN
        lineptr^[j]:=ADDRESS(ptr)+ADDRESS(1);
        INC(j);
      END;
      INC(ptr);
    END;
    RETURN TRUE;
  END;
  RETURN FALSE;
END InitGlobs;


PROCEDURE Print;
(* Prints the file *)
VAR
  file : FileHandle;
  x    : LONGINT;
BEGIN
  ZZOn;
  file:=Open("PRT:",ModeNewFile);
  IF file # 0 THEN
    x:=Write(file,buffer,filesize);
    Close(file);
  END;
  ZZOff;
END Print;


PROCEDURE Main;
VAR
  msg   : IntuiMessagePtr;
  class : IDCMPFlagSet;
  code  : CARDINAL;
  gadgetptr : GadgetPtr;
BEGIN
  UpdateDisplay;
  NewModifyProp(ADR(gadgets[2]),wp,NULL,slider.Flags,
                65535,0,65535,vbody,-1);
  class:=IDCMPFlagSet{};

  LOOP
    IF class # IDCMPFlagSet{GadgetDown} THEN
      msg:=WaitPort(wp^.UserPort);
    END;
    msg:=GetMsg(wp^.UserPort);
    IF msg # NULL THEN
      class:=msg^.Class;
      code:=msg^.Code;
      gadgetptr:=msg^.IAddress;
      ReplyMsg(MessagePtr(msg));
      IF class=IDCMPFlagSet{CloseWindowFlag} THEN
        EXIT;
      END;
    END;
    IF class=IDCMPFlagSet{GadgetDown} THEN
      IF gadgetptr^.GadgetID=0 THEN
        DownDisplay;
      ELSE
        UpDisplay;
      END;
      NewModifyProp(ADR(gadgets[2]),wp,NULL,slider.Flags,
                    65535,slider.VertPot,65535,vbody,1);
    ELSIF (class=IDCMPFlagSet{MouseButtons}) & (code=SelectUp) THEN
      class:=IDCMPFlagSet{};
    ELSIF class=IDCMPFlagSet{MenuPick} THEN
      CASE (code DIV 32) MOD 64 OF
        0: EXIT; |
        1: Print;|
        2: quit:=TRUE;
           EXIT; |
      END;
    ELSIF class=IDCMPFlagSet{GadgetUp} THEN
      IF (gadgetptr^.GadgetID=2) & (numlines>22) THEN
        topline:=SHORT(LONG(numlines-22)*LONG(slider.VertPot) DIV 65536);
        UpdateDisplay;
      END;
    END;
  END;
END Main;


BEGIN
(* Open all libraries and stuff, read in files, and then go backwards and
   deallocate everything *)

  StartUp;
  pointerdata:=NULL;
  
  DOSBase:=OpenLibrary(DOSName,33);
  IF DOSBase # NULL THEN
    GraphicsBase:=OpenLibrary(GraphicsName,33);
    IF GraphicsBase # NULL THEN
      IntuitionBase:=OpenLibrary(IntuitionName,33);
      IF IntuitionBase # NULL THEN
        sp:=InitScreen();
        IF sp # NULL THEN
          InitGadgets;
          InitMenu;
          wp:=InitWindow();
          IF wp # NULL THEN
            myproc^.prWindowPtr:=wp;
            wp2:=InitWindow2();
            IF wp2 # NULL THEN
              wp2^.UserPort:=wp^.UserPort; (* So that CloseWindowFlag message
                                              arrives at the same msgport *)
              ModifyIDCMP(wp2,IDCMPFlagSet{CloseWindowFlag});
              rp:=ADR(sp^.RPort);
              SetAPen(rp,1);
              RectFill(rp,626,11,639,199);
              SetAPen(rp,0);
              RectFill(rp,628,12,637,198);
              quit:=FALSE;

              WHILE (GetNextArgument(filename,filelock)) & (NOT quit) DO
                ZZOn;
                IF filelock # 0 THEN
                  filelock:=CurrentDir(filelock);
                END;
                filesize:=GetFileSize(filename);
                IF filesize # 0 THEN
                  buffer:=AllocMem(filesize,MemReqSet{MemPublic});
                  IF buffer # NULL THEN
                    buf2:=buffer+ADDRESS(filesize);
                    file:=Open(filename,ModeOldFile);
                    IF file # 0 THEN
                      x:=Read(file,buffer,filesize);
                      Close(file);
                      IF InitGlobs() THEN
                        ZZOff;
                        SetMenuStrip(wp,menu);
                        Main;
                        ClearMenuStrip(wp);
                        FreeMem(buf3,numberoflines);
                      END;
                    END;
                    FreeMem(buffer,filesize);
                  END;
                END;
              END;
              wp2^.UserPort:=NULL;
              CloseWindow(wp2);
            END;
            myproc^.prWindowPtr:=NULL;
            CloseWindow(wp);
          END;
          CloseScreen(sp);
        END;
        CloseLibrary(IntuitionBase);
      END;
      CloseLibrary(GraphicsBase);
    END;
    CloseLibrary(DOSBase);
  END;

  CloseUp;
END Viewer.
